#------------------------------------------------------------------------
#$Author: antanas $
#$Date: 2021-04-28 17:11:36 +0300 (Wed, 28 Apr 2021) $
#$Revision: 8737 $
#$URL: svn+ssh://www.crystallography.net/home/coder/svn-repositories/cod-tools/tags/v3.10.0/src/lib/perl5/COD/ToolsVersion.pmin $
#------------------------------------------------------------------------
#*
# Provides version number for Perl programs in the 'cod-tools' package.
#**

package COD::ToolsVersion;

use strict;
use warnings;

require Exporter;
our @ISA = qw( Exporter );
our @EXPORT_OK = qw(
    get_version_number
    get_version_string
);

# FIXME: the $COD::ToolsVersion::Version variable is considered
# deprecated and should be replaced with a locally scoped one
$COD::ToolsVersion::Version = "3.10.0";
my $PACKAGE = 'cod-tools';

##
# Retrieves the 'cod-tools' software package version number.
##
sub get_version_number
{
    return $COD::ToolsVersion::Version;
}

##
# Retrieves the 'cod-tools' software package version string that consists
# of the package name, the version number and some additional text.
##
sub get_version_string
{
    return "$PACKAGE version $COD::ToolsVersion::Version";
}

1;
